/* Adaptive Huffman decoding program */
/* Hal Burch */
/* Sept 16, 1996 */

/* This is based on the Adaptive Huffman algorithm described in Sayood's Data
 * Compression book.  The ranks are not actually stored, but implicitly defined
 * by the location of a node within a doubly-linked list */


/*******************************************************************************
*NOTICE:                                                                       *
*This code is believed by the author to be bug free.  You are free to use and  *
*modify this code with the understanding that any use, either direct or        *
*derivative, must contain acknowledgement of its author and source.  The author*
*makes no warranty of any kind, expressed or implied, of merchantability or    *
*fitness for a particular purpose.  The author shall not be held liable for any*
*incidental or consequential damages in connection with or arising out of the  *
*furnishing, performance, or use of this software.  This software is not       *
*authorized for use in life support devices or systems.                        *
********************************************************************************/
/* modifed by David A. Scott so could be useful for cryptographic purposes */
/* #define DEBUG 1 */
/* #define ASSERT 1 */ 
/*  old #define MAX 256 /* Maximum symbol */
#define MAX 255 /* Maximum symbol */
#define N 8 /* number of bits */

#include <stdio.h>
#include <assert.h>
#include <malloc.h>
#include <string.h>
#include "ad2hc.h"

char buff[130];
int bloc=128*8;
int outcch=0;
  int cch;
Node *tree;
Node *lhead, *ltail;
Node *loc[MAX+1];
Node TREE[520];
Node *CP[MAX +1];
Node **CPP;
static int FONE;
static int NZZS=0;
static int LASTONE;
static int PCOLD=0;
static int FZ=0,PC=0,BC=0;
int get_bit (FILE *fin)
 { /* Receive one bit from the input file (buffered) */
  int t,jj,kk;

/* new shit */
  static int fpflag=0;
  if (!fpflag){ 
    t = fread(buff+128, sizeof(char),2,fin);
    cch = t * 8;
#ifdef ASSERT
    assert ( t >= 1);
#endif
    fpflag = 1; }


  if (bloc == 128*8)
   {
    buff[0]=buff[128];
    buff[1]=buff[129];
    t = fread(buff+2, sizeof(char), 128, fin);
#ifdef ASSERT
    assert (t >= 0);
#endif
    cch +=t*8;
    bloc = 0;
   }
  cch--;
  t = (buff[bloc/8] >> (7-(bloc % 8))) & 0x1;
 
  jj = bloc%8; /* the current bit from 0 to 7 on byte */
  if ( FONE ) 
    {  /* get final status of previous huffman code */
      kk = NZZS ==  jj ;  /* true if trailing ones on prevoius code */
      if ( (BC > 8) && kk && (jj != 0))
         PCOLD = PC || PCOLD ||  FZ == 8 || BC > 16;
      else
         PCOLD = 0; /* zero if not a cuttoff one condition */
     FZ = t == 0 ?1:0;
     PC = t;
     BC = jj+1; /* bit counter */
    } 
  else { 
    BC++;
    if (BC < 9 ){
      PC |= t;  /* if a one in first byte */
      if ( t==0 ) FZ++;
      }
  }
  

  if ( cch < 7 && FONE ){
    LASTONE=t^1;
    if ( cch + NZZS > 6 && t==0)LASTONE = !PCOLD;
    if ( (unsigned char)(buff[bloc/8] << (8-cch)) !=0) LASTONE=0;
    if ( LASTONE == 1) cch=0;
 }
 if ( FONE == 1) NZZS=0;
 else {
 if ( bloc % 8 == 0 ) NZZS=0;
 NZZS += t;
 }

 bloc++;
 if( cch < 0) t =1; /* if reading  unknown stuff */
  FONE = 0;
  return t;
 }
int receive (Node *node, int *ch, FILE *fin)
 { /* Get a symbol */
  while (node && node->symbol == INTERNAL_NODE)
   {
    if (get_bit(fin))
      node = node->right;
    else
      node = node->left;
   if(LASTONE)break;
   }
  if (!node)
   {
    fprintf (stderr, "Illegal tree!\n");
    exit(5);
   }
  return (*ch = node->symbol);
 }

void main(int argc, char **argv)
 {
  FILE *fin;
  FILE *fout;
  int ch,i,j,k,n,loop=0;
  char tch;
  char tw[4];
  if (argc != 3)
   {
    usage(argv);
    exit(3);
   }

  if ((fin = fopen(argv[1], "rb")) == NULL)
   {
    fprintf (stderr, "Cannot open input file.\n");
    usage(argv);
    exit(3);
   }

  if ((fout = fopen(argv[2], "wb")) == NULL)
   {
    fprintf (stderr, "Cannot open output file.\n");
    usage(argv);
    exit(3);
   }


/* new stuff */


/****/
n= 256-1; /* number of leaf nodes -1 */
CPP=&CP[0];
 for(i = n,j=0; i<=2*n; i++,j++){
 TREE[i].parent= &TREE[(i-1)/2];
  if( i & 0x1)
  TREE[(i-1)/2].right= &TREE[i];
 else
  TREE[(i-1)/2].left= &TREE[i];
 TREE[i].next= &TREE[i-1];
 TREE[i].prev= &TREE[i+1];
 TREE[i].weight=1;
 TREE[i].right=NULL;
 TREE[i].left=NULL;
 TREE[i].head=CPP;
 loc[j]=&TREE[i];
 TREE[i].symbol= j;
}  
 *CPP++ = &TREE[n];
 lhead=&TREE[2*n]; 
 TREE[2*n].prev=NULL;
 /*   TREE[n].next=NULL;
    checkranks(lhead->next); */
for(j=n-1; j!=0; j=(j/2)-1){
for(i=j,k=j/2; i>=k; i--){
 TREE[i].parent= &TREE[(i-1)/2];
  if( i & 0x1)
  TREE[(i-1)/2].right= &TREE[i];
 else
  TREE[(i-1)/2].left= &TREE[i];
 TREE[i].next= &TREE[i-1];
 TREE[i].prev= &TREE[i+1];
 TREE[i].weight= TREE[i].right->weight +TREE[i].left->weight;
 TREE[i].head=CPP;
 TREE[i].symbol= INTERNAL_NODE;
}  
 *CPP++ = &TREE[k];
}

 TREE[0].parent= NULL;
 TREE[0].next= NULL;
 TREE[0].prev= &TREE[1];
 TREE[0].weight= TREE[0].right->weight +TREE[0].left->weight;
 TREE[0].head=CPP;
 TREE[0].symbol= INTERNAL_NODE;
 *CPP++ = &TREE[0];
    tree= &TREE[0];

cch=1000;

  while (cch > 0)
   {
/*
    if (++loop % 1024 == 0) 
     {
      printf (".");
      loop=0;
      fflush (stdout);
     }    
*/

/* Get a character */
    FONE =1;
    LASTONE =0;
    receive(tree, &ch, fin);
    if (LASTONE)break;
    
/* Write symbol */
    tch = ch; 
    fwrite (&tch, sizeof(char), 1, fout);

/* Increment node */
    add_ref(ch);
#ifdef DEBUG
    checkranks(lhead->next); 
#endif

#ifdef TRACE    
    dumptree(tree);
    dumplist(lhead);
#endif
   }
  printf (" program h2unc.exe version 20000110");
  printf ("\n");

  fclose(fin);
  fclose(fout);
  exit(7);
 }
